% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Evaluation.R
\name{.prepare_familiar_data_sets}
\alias{.prepare_familiar_data_sets}
\title{Prepare familiarData objects for evaluation at runtime.}
\usage{
.prepare_familiar_data_sets(
  cl = NULL,
  only_pooling = FALSE,
  message_indent = 0L,
  verbose = FALSE
)
}
\arguments{
\item{cl}{Cluster for parallel processing.}

\item{only_pooling}{Flag that, if set, forces evaluation of only the
top-level data, and not e.g. ensembles.}

\item{message_indent}{indent that messages should have.}

\item{verbose}{Sets verbosity}
}
\value{
A data.table with created links to created data objects.
}
\description{
Information concerning models, features and the experiment is
processed and stored in familiarData objects. Information can be extracted
from these objects as csv files, or by plotting, or multiple objects can be
combined into familiarCollection objects, which allows aggregated exports.
}
\details{
This function generates the names of familiarData object files, and
their corresponding generating ensemble, which allows the familiarData
objects to be created.
}
\keyword{internal}
